=== src/linkgraph/CMakeLists.txt ===
add_files(
    demands.cpp
    demands.h
    flowmapper.cpp
    flowmapper.h
    init.h
    linkgraph.cpp
    linkgraph.h
    linkgraph_base.h
    linkgraph_gui.cpp
    linkgraph_gui.h
    linkgraph_type.h
    linkgraphjob.cpp
    linkgraphjob.h
    linkgraphjob_base.h
    linkgraphschedule.cpp
    linkgraphschedule.h
    mcf.cpp
    mcf.h
    refresh.cpp
    refresh.h
)
