=== src/3rdparty/md5/CMakeLists.txt ===
add_files(
    md5.cpp
    md5.h
)
