=== src/3rdparty/os2/CMakeLists.txt ===
add_files(
    getaddrinfo.c
    getaddrinfo.h
    getnameinfo.c
    getnameinfo.h
    CONDITION OPTION_OS2
)
