=== src/os/macosx/CMakeLists.txt ===
add_files(
    crashlog_osx.cpp
    font_osx.cpp
    font_osx.h
    macos.h
    macos.mm
    osx_stdafx.h
    string_osx.cpp
    string_osx.h
    CONDITION APPLE
)
