=== debian/changelog ===
openttd (13.0-2) unstable; urgency=medium

  * [c3e16af] Fix cross-compilation by building build-time tools in a
    separate pass. Thanks to Helmut Grohne for the initial patch. (Closes:
    #1020921)

 -- Matthijs Kooijman <matthijs@stdin.nl>  Sun, 19 Feb 2023 15:38:12 +0100

openttd (13.0-1) unstable; urgency=medium

  [ Debian Janitor ]
  * [521c8eb] Remove constraints unnecessary since buster

  [ Matthijs Kooijman ]
  * [8805ef2] New upstream release 13.0
  * [56910c6] Bump standards version to 4.6.2 (no changes required)
  * [866fa62] Use new libfreetype-dev name in build-depends

 -- Matthijs Kooijman <matthijs@stdin.nl>  Wed, 15 Feb 2023 18:46:13 +0100
