## openttd 13.4

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 endif()
 
 project(${BINARY_NAME}
-    VERSION 13.0
+    VERSION 13.4
 )
 
 if(CMAKE_SOURCE_DIR STREQUAL CMAKE_BINARY_DIR)
@@ -280,6 +280,8 @@
     endif()
 endif()
 
+include(CheckAtomic)
+
 if(APPLE)
     link_package(Iconv TARGET Iconv::Iconv)
