=== src/pathfinder/CMakeLists.txt ===
add_subdirectory(npf)
add_subdirectory(yapf)

add_files(
    follow_track.hpp
    pathfinder_func.h
    pathfinder_type.h
)
