=== src/3rdparty/squirrel/CMakeLists.txt ===
add_subdirectory(include)
add_subdirectory(sqstdlib)
add_subdirectory(squirrel)
