=== debian/changelog ===
openttd (13.4-1build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 18:03:42 +1100

openttd (13.4-1build2) noble; urgency=medium

  * No-change rebuild against libpng16-16t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 29 Feb 2024 07:46:23 +0000

openttd (13.4-1build1) noble; urgency=medium

  * No-change rebuild for ICU soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 19 Dec 2023 11:07:38 +0100

openttd (13.4-1) unstable; urgency=medium

  * [72a0233] New upstream release 13.4 (Closes: #1053950, #1032180)

 -- Matthijs Kooijman <matthijs@stdin.nl>  Sat, 25 Nov 2023 18:04:32 +0100
