=== debian/control ===
--- 
+++ 
@@ -1,7 +1,8 @@
 Source: openttd
 Section: games
 Priority: optional
-Maintainer: Matthijs Kooijman <matthijs@stdin.nl>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Matthijs Kooijman <matthijs@stdin.nl>
 Uploaders: Jordi Mallach <jordi@debian.org>
 Build-Depends: debhelper-compat (= 13), libsdl2-dev, zlib1g-dev, libpng-dev,
  libfreetype-dev, libfontconfig-dev, libicu-dev, liblzo2-dev, liblzma-dev,
